<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/paper-input/paper-textarea.html">
<link rel="import" href="/extern/bower_components/paper-checkbox/paper-checkbox.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">

<!--

`command-input` receives three values 'name', 'value', and 'type' and converts it into an appropriate input element.

Examples:

    <command-input name="dinosaurs are great" value="true" type="bool"></command-input>
    <command-input name="your_favorite_dinosaur" value="deinonychus" type="string"></command-input>
    <command-input name="positive number" value="0" type="unsigned int"></command-input>

Currently, command-input recognizes the following data types:
  - number
  - int
  - long
  - unsigned int
  - unsigned long
  - short
  - unsigned short
  - string
  - double
  - float

@authors Glenn Dirkx
@demo demo/index.html

-->

<dom-module id="command-input">
  <template>
    <style include="reset-css"></style>
    <link rel="stylesheet" type="text/css" href="css/command-input-min.css?__inline=true">

    <template is="dom-if" if="[[_isBoolean(type)]]" restamp="true">
      <paper-checkbox checked=[[_toBool(value)]] on-change="_updateBool">{{name}}</paper-checkbox>
    </template>
    <template is="dom-if" if="[[!_isBoolean(type)]]" restamp="true">
      <paper-textarea  label="[[_toLabel(name, type)]]"
                       value="{{value}}"
                       type="[[_toType(type)]]"
                       pattern="[[_getValidationPattern(type)]]"
                       allowed-pattern="[[_getInputPattern(type)]]"
                       min="[[_getMin(type)]]"
                       auto-validate
                       error-message="invalid"
                       on-change="_bleh"
                       invalid="{{invalid}}"
                       always-float-label="{{alwaysFloatLabel}}"></paper-textarea>
    </template>

  </template>
  <script src="javascript/command-input-min.js?__inline=true"></script>
</dom-module>
